import bns
import datetime

#the following elements need to be present in your database. If you want to use an element 
# already in your database with an different name, change the right part of the = to match the name in your database (keep the quotes)
BlastDb = "emm"
seqexp = "emm"
emmTypeField = "emmType"
nHitsField = "NUMBER_OF_HITS"
CommentField = "Comments"	

			
now = datetime.datetime.now()
blastwin=bns.Blast.BlastWin()
blastwinSave=bns.Blast.BlastWin()
blastjob=bns.Blast.BlastJob()
blastjobSave=bns.Blast.BlastJob()
blastname = "BlastJob" + str(now)
blastjob.Create("blast")
blastjobSave.Create(blastname)
blastjob.SetDatabase(BlastDb,"local")
blastjob.SetProgram('blastn')
blastjobSave.SetDatabase(BlastDb,"local")
blastjobSave.SetProgram('blastn')


#setting up the blast calculation
class BlastCalculation(object):
	def doCalc(self,dct):
		commObj = dct["communication"]
		blastjobSave.SetCalcCommunication(commObj)
		blastjobSave.Run()
	def refresh(self,dct):
		bns.Blast.BlastWin.AttachJob(blastwinSave,blastjobSave)

wnd = bns.Windows.BnsWindow(1) 
obj = BlastCalculation()
		
sel = bns.Database.Db.Selection
for entry in sel:
	
	if bns.Database.Experiment(entry.Key, seqexp).ExperID:
		blastjob.Reset()
		blastjob.AddEntry(entry.Key,seqexp)
		blastjobSave.AddEntry(entry.Key,seqexp)
		blastjob.Run()
		try: 
			FirstHit = blastjob.GetHitHSeqKey(0)
			emmType = FirstHit.split(" ")[0]
			count = 0
		
			FirstHitIdentity = blastjob.GetHitIdentity(0)
			if round(FirstHitIdentity,2) == 100:
				count = count +1
				entry.Field(emmTypeField).Content = emmType
				if blastjob.GetHitAlignLen(0)<180:
					entry.Field(CommentField).Content= "Hit is too short, check if sequence is not partial sequence"
				if blastjob.GetHitAlignLen(0)>180:
					entry.Field(CommentField).Content= "Hit is too long, check in alignment window"
				for n in range(1,blastjob.GetHitCount()):
				
					SecondHitIdentity = blastjob.GetHitIdentity(n)
					if round(FirstHitIdentity,2) <= round(SecondHitIdentity,2):
						count = count +1
					else:
						break
		except:
			entry.Field(CommentField).Content= "No blast results"
			pass
	entry.Field(nHitsField).Content = str(count)
bns.Database.Db.Fields.Save()
wnd.StartAsyncCalculation(obj.doCalc, obj.refresh, asynch=False)


	
	
